format ELF

include 'cdecl.inc'
include 'gtk.inc'

public main

; extrn blah

extrn g_print
extrn gtk_init
extrn gtk_window_new
extrn gtk_signal_connect
extrn g_list_append
extrn gtk_combo_new
extrn gtk_combo_set_popdown_strings
extrn gtk_container_add
extrn gtk_container_set_border_width
extrn gtk_widget_show
extrn gtk_main
extrn exit

section '.data' writeable

    szDeleteEvent   db "delete_event", 0
    szExitMsg       db "closing application...", 10, 10, 0
    szItem1         db "Banana", 0
    szItem2         db "Orange", 0
    szItem3         db "Peach", 0
    szItem4         db "Strawberry", 0

section '.bss' writeable

    hWindow         dd ?
    hCombo          dd ?
    hItems          dd ?

section '.text' executable

proc main argc, argv

    lea eax, [argc]
    lea ebx, [argv]

    ccall gtk_init, eax, ebx

    ccall gtk_window_new, GTK_WINDOW_TOPLEVEL
    mov [hWindow], eax

    ccall gtk_signal_connect, [hWindow], szDeleteEvent, DeleteEvent, 0

    ccall g_list_append, [hItems], szItem1
    mov [hItems], eax
    ccall g_list_append, [hItems], szItem2
    mov [hItems], eax
    ccall g_list_append, [hItems], szItem3
    mov [hItems], eax
    ccall g_list_append, [hItems], szItem4
    mov [hItems], eax

    call gtk_combo_new
    mov [hCombo], eax

    ccall gtk_combo_set_popdown_strings, [hCombo], [hItems]

    ccall gtk_container_add, [hWindow], [hCombo]

    ccall gtk_container_set_border_width, [hWindow], 15

    ccall gtk_widget_show, [hCombo]
    ccall gtk_widget_show, [hWindow]

    call gtk_main

    ret

endp

proc DeleteEvent widget, gdata
    ccall g_print, szExitMsg
    ccall exit, 0
    ret
endp
