format ELF

include 'cdecl.inc'
include 'gtk.inc'

public main

; extrn blah

extrn g_print
extrn gtk_init
extrn gtk_window_new
extrn gtk_signal_connect
extrn gtk_container_add
extrn gtk_container_set_border_width
extrn gtk_widget_show
extrn gtk_main
extrn exit
extrn gtk_box_pack_start
extrn gtk_hbox_new
extrn gtk_toggle_button_new_with_label

section '.data' writeable

    szDeleteEvent   db "delete_event", 0
    szExitMsg	    db "closing application...", 10, 10, 0
    szToggle1	    db "Toggle 1", 0
    szToggle2	    db "Toggle 2", 0
    szToggle3	    db "Toggle 3", 0
    szToggle4	    db "Toggle 4", 0
    szToggle5	    db "Toggle 5", 0

section '.bss' writeable

    hWindow	    dd ?
    hHbox	    dd ?
    hToggle1	    dd ?
    hToggle2	    dd ?
    hToggle3	    dd ?
    hToggle4	    dd ?
    hToggle5	    dd ?


section '.text' executable

proc main argc, argv

    lea eax, [argc]
    lea ebx, [argv]

    ccall gtk_init, eax, ebx

    ccall gtk_window_new, GTK_WINDOW_TOPLEVEL
    mov [hWindow], eax

    ccall gtk_hbox_new, FALSE, 0
    mov [hHbox], eax

    ccall gtk_signal_connect, [hWindow], szDeleteEvent, DeleteEvent

    ccall gtk_toggle_button_new_with_label, szToggle1
    mov [hToggle1], eax
    ccall gtk_toggle_button_new_with_label, szToggle2
    mov [hToggle2], eax
    ccall gtk_toggle_button_new_with_label, szToggle3
    mov [hToggle3], eax
    ccall gtk_toggle_button_new_with_label, szToggle4
    mov [hToggle4], eax
    ccall gtk_toggle_button_new_with_label, szToggle5
    mov [hToggle5], eax

    ccall gtk_box_pack_start, [hHbox], [hToggle1], TRUE, TRUE, 2
    ccall gtk_box_pack_start, [hHbox], [hToggle2], TRUE, TRUE, 2
    ccall gtk_box_pack_start, [hHbox], [hToggle3], TRUE, TRUE, 2
    ccall gtk_box_pack_start, [hHbox], [hToggle4], TRUE, TRUE, 2
    ccall gtk_box_pack_start, [hHbox], [hToggle5], TRUE, TRUE, 2

    ccall gtk_container_add, [hWindow], [hHbox]

    ccall gtk_container_set_border_width, [hWindow], 15

    ccall gtk_widget_show, [hToggle1]
    ccall gtk_widget_show, [hToggle2]
    ccall gtk_widget_show, [hToggle3]
    ccall gtk_widget_show, [hToggle4]
    ccall gtk_widget_show, [hToggle5]
    ccall gtk_widget_show, [hHbox]
    ccall gtk_widget_show, [hWindow]

    call gtk_main

    ret

endp

proc DeleteEvent widget, gdata
    ccall g_print, szExitMsg
    ccall exit, 0
    ret
endp
