format ELF

include 'cdecl.inc'
include 'gtk.inc'

public main

; extrn blah

extrn g_print
extrn gtk_init
extrn gtk_window_new
extrn gtk_button_new_with_label
extrn gtk_signal_connect
extrn gtk_container_add
extrn gtk_container_set_border_width
extrn gtk_widget_show
extrn gtk_main
extrn exit

section '.data' writeable

    szDeleteEvent   db "delete_event", 0
    szExitMsg	    db "closing application...", 10, 10, 0
    szClicked	    db "clicked", 0
    szClickMe	    db "Click me!", 0
    szWasClicked    db "Button was clicked...", 10, 10, 0

section '.bss' writeable

    hWindow	    dd ?
    hButton	    dd ?

section '.text' executable

proc main argc, argv

    lea eax, [argc]
    lea ebx, [argv]

    ccall gtk_init, eax, ebx

    ccall gtk_window_new, GTK_WINDOW_TOPLEVEL
    mov [hWindow], eax

    ccall gtk_button_new_with_label, szClickMe
    mov [hButton], eax

    ccall gtk_signal_connect, [hWindow], szDeleteEvent, DeleteEvent
    ccall gtk_signal_connect, [hButton], szClicked, ButtonClick

    ccall gtk_container_add, [hWindow], [hButton]

    ccall gtk_container_set_border_width, [hWindow], 15

    ccall gtk_widget_show, [hButton]
    ccall gtk_widget_show, [hWindow]

    call gtk_main

    ret

endp

proc DeleteEvent widget, gdata
    ccall g_print, szExitMsg
    ccall exit, 0
    ret
endp

proc ButtonClick widget, gdata
    ccall g_print, szWasClicked
    ret
endp