format ELF

include 'cdecl.inc'
include 'gtk.inc'

public main

; extrn blah

extrn gtk_calendar_new
extrn gtk_window_new
extrn gtk_signal_connect
extrn gtk_container_add
extrn gtk_widget_show
extrn gtk_main
extrn gtk_init
extrn g_print
extrn exit

section '.data' writeable

    szDeleteEvent   db "delete_event", 0
    szExitMsg       db "closing application...", 10, 10, 0

section '.bss' writeable

    hWindow         dd ?
    hCalendar       dd ?

section '.text' executable

proc main argc, argv

    lea eax, [argc]
    lea ebx, [argv]

    ccall gtk_init, eax, ebx

    call gtk_calendar_new
    mov [hCalendar], eax

    ccall gtk_window_new, GTK_WINDOW_TOPLEVEL
    mov [hWindow], eax

    ccall gtk_signal_connect, [hWindow], szDeleteEvent, DeleteEvent, 0

    ccall gtk_container_add, [hWindow], [hCalendar]

    ccall gtk_widget_show, [hCalendar]
    ccall gtk_widget_show, [hWindow]

    call gtk_main

    ret

endp

proc DeleteEvent widget, gdata
    ccall g_print, szExitMsg
    ccall exit, 0
    ret
endp
