format ELF

include 'cdecl.inc'
include 'gtk.inc'

public main

; extrn blah

extrn g_print
extrn gtk_init
extrn gtk_window_new
extrn gtk_check_button_new_with_label
extrn gtk_signal_connect
extrn gtk_container_add
extrn gtk_container_set_border_width
extrn gtk_widget_show
extrn gtk_main
extrn exit
extrn gtk_box_pack_start
extrn gtk_hbox_new

section '.data' writeable

    szDeleteEvent   db "delete_event", 0
    szExitMsg       db "closing application...", 10, 10, 0
    szCheck1        db "Check 1", 0
    szCheck2        db "Check 2", 0
    szCheck3        db "Check 3", 0

section '.bss' writeable

    hWindow         dd ?
    hCheck1         dd ?
    hCheck2         dd ?
    hCheck3         dd ?
    hHbox           dd ?

section '.text' executable

proc main argc, argv

    lea eax, [argc]
    lea ebx, [argv]

    ccall gtk_init, eax, ebx

    ccall gtk_window_new, GTK_WINDOW_TOPLEVEL
    mov [hWindow], eax

    ccall gtk_hbox_new, FALSE, 0
    mov [hHbox], eax

    ccall gtk_signal_connect, [hWindow], szDeleteEvent, DeleteEvent

    ccall gtk_check_button_new_with_label, szCheck1
    mov [hCheck1], eax
    ccall gtk_check_button_new_with_label, szCheck2
    mov [hCheck2], eax
    ccall gtk_check_button_new_with_label, szCheck3
    mov [hCheck3], eax

    ccall gtk_box_pack_start, [hHbox], [hCheck1], TRUE, TRUE, 2
    ccall gtk_box_pack_start, [hHbox], [hCheck2], TRUE, TRUE, 2
    ccall gtk_box_pack_start, [hHbox], [hCheck3], TRUE, TRUE, 2

    ccall gtk_container_add, [hWindow], [hHbox]

    ccall gtk_container_set_border_width, [hWindow], 15

    ccall gtk_widget_show, [hCheck1]
    ccall gtk_widget_show, [hCheck2]
    ccall gtk_widget_show, [hCheck3]
    ccall gtk_widget_show, [hHbox]
    ccall gtk_widget_show, [hWindow]

    call gtk_main

    ret

endp

proc DeleteEvent widget, gdata
    ccall g_print, szExitMsg
    ccall exit, 0
    ret
endp
